package inheritance;

public class ColoredTriangle extends ColoredShape {
   private double sideLength;
   
   public ColoredTriangle(double sideLength, int color) {
      this.sideLength = sideLength;
      this.setColor(color); // Where did this method come from?
   }

   /* Because ColoredShape implements Shape, we also 
    * have to define the area() and numSides() methods
    */
   public double area() {
      return sideLength * sideLength / 2;
   }
   
   public int numSides() {
      return 3;
   }
   
   // area2() and numSides2() are abstract methods from ColoredShape
   public double area2() {
      return this.getColor() * this.area();
   }
   
   public int numSides2() {
      return this.getColor() * this.numSides();
   }
}