package inheritance;

public class ShapeUser {
    public static void main(String[] args) {
        Rectangle r = new Rectangle(5.0, 10.0);
        Square s = new Square(3.0);
        ColoredShape c = new ColoredTriangle(2.0, 3);
        ColoredTriangle t = new ColoredTriangle(4.0, 2);

        useRect(r);
        useSquare(s);

        useRect(s);
       //  useSquare(r); // Will this work?
        
        useShape(c);
        useColoredShape(c);
        useShape(t);
        useColoredShape(t);
        
        // Will these work?
        // useColoredShape(r);
        // useColoredShape(s);
    }

    // Can we use the rectangle here? Only some rectangles are squares!
    public static void useSquare(Square sq) {
        System.out.println("Sqaure area: " + sq.area());
    }

    // Can we use the square here? Squares are rectangles!
    public static void useRect(Rectangle rect) {
        System.out.println("Rectangle area: " + rect.area());
    }
    
    // Can we use the rectanges and squares here? Only some Shape objects are ColoredShapes! 
    public static void useColoredShape(ColoredShape shape) {
        System.out.println("Colored shape area: " + shape.area2());
    }

    // Can we use the colored triangle here? ColoredShapes are Shapes!
    public static void useShape(Shape shape) {
        System.out.println("Shape area: " + shape.area());
    }
}
